/* This sketch provided "AS IS" under the BSD New license.
http://opensource.org/licenses/BSD-3-Clause
April 2015 © blog@rr-m.org

download tx_rw_wheel_reader.ino above - it has more comments */
#include <SPI.h>
#include <Arduino.h>

const int slaveSelectPin = 7;

void setup() {
 Serial.begin(9600);
 SPCR |= _BV(CPHA);
 SPCR |= _BV(CPOL);
 SPI.beginTransaction(SPISettings(400000, MSBFIRST, SPI_MODE0));
 SPI.begin();
 pinMode(slaveSelectPin, OUTPUT);
}

void loop() {
 // tell the wheel, that we gonna read the data now
 digitalWrite(slaveSelectPin, LOW);

 // read 3 bytes and output them to Arduino Serial monitor
 // as binaries 11000001 11111111 11111111
 // last 17 bits are buttons. 1 - released, 0 - pressed.
 for(int i=1; i<=8; i++) {
   delayMicroseconds(100);
   printBinary(SPI.transfer(0x00));
 }
 Serial.println();

 // release the wheel
 digitalWrite(slaveSelectPin, HIGH);

 // wait 1 second, then read data from wheel again
 delay(1000);
}

// print byte as binary, zero padded if needed
// "127" -> "01111111"
void printBinary(byte data) {
 for(int i=7; i>0; i--) {
   if (data >> i == 0) {
     Serial.print("0");
   } else {
     break;
   }
 }
 Serial.print(data,BIN);
 Serial.print(" ");
}
